/* defenseSimulation.h
 */
#ifndef _DEFENSE_SIMULATION_H
#define _DEFENSE_SIMULATION_H

#include "osl/state/numEffectState.h"

namespace osl
{
  class PathEncoding;
  namespace checkmate
  {
    class CheckHashRecord;
    class CheckMove;
    /**
     * @param P ¦
     */
    template <Player P>
    struct DefenseSimulation
    {
      /** 
       * oracle ȿڤ줿ˡdrop  oracle.move.ptype() Ʊ郎
       * ȿڤǤ뤫ɤ򥷥ߥ졼󤹤롥
       * @param key  state key
       * @param path state path
       */
      template <class Table>
      static void disproofDropSibling(NumEffectState& state, 
				      const HashKey& key,
				      const PathEncoding& path,
				      CheckHashRecord *record, Table& table,
				      const CheckMove& oracle,
				      size_t& node_count);
      /**
       * NoPromote :
       * target ؤ塤guide ƱͤȿڤǤ뤫ɤΤ
       * @param state target ؤ
       * @param new_key target ؤ
       * @param new_path target ؤ
       */
      template <class Table>
      static bool disproofNoPromote(NumEffectState& state, 
				    const HashKey& new_key,
				    const PathEncoding& new_path,
				    CheckHashRecord *record, Table& table, 
				    CheckMove& target, 
				    const CheckMove& guide, size_t& node_count);
    private:
      /**
       * target ؤ塤guide ƱͤȿڤǤ뤫ɤΤ
       */
      template <class Table>
      static bool disproof(NumEffectState& state, 
			   const HashKey& new_key,
			   const PathEncoding& new_path, 
			   Table& table, const CheckMove& target, 
			   CheckHashRecord *guide, size_t& node_count);

    };
  } // namespace checkmate
} // namespace osl

#endif /* _DEFENSE_SIMULATION_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
