#ifndef _EFFECTUTIL_H
#define _EFFECTUTIL_H

#include "osl/state/numEffectState.h"
#include "osl/misc/carray.h"
#include "osl/container/pieceVector.h"

#include <iosfwd>
#include <cassert>

namespace osl
{
  namespace container
  {
    class PieceVector;
  }

  namespace effect_util
  {
  /**
   * EffectState Ѥ뤿Υ᥽å
   * NumSimpleEffect ʤɤθ󥿡ե
   * Ȥäƽ񤱤륳
   */
  struct EffectUtil
  {
    /**
     * effectTarget ΤäȤ¤õ
     * @return ޤϡ̵ Piece::EMPTY() ֤
     * @param P õоݤζνͭ
     * @param effectTarget on board Ǥ뤳
     */
    static Piece cheapestPiece(Player P, const NumEffectState&, 
			       Position effectTarget);
    static Ptype cheapestPtype(Player P, const NumEffectState&, 
			       Position effect_target);
    /**
     * pos Τ promote ǽ ptype Ķõ
     * pos  promote ǽʥޥɤϸʤ
     * @return ޤϡ̵ Piece::EMPTY() ֤
     * @param P õоݤζνͭ
     * @param effectTarget on board Ǥ뤳
     */
    static Piece promotablePiece(Player P, const NumEffectState&, 
				 Position effectTarget);


    /** 
     * target ˤɽ
     */
    static void showEffect(const NumEffectState& state, Position target,
			   std::ostream&);

    /**
     * PtypeO  Position ˤȲꤷˤ.
     * ̤ºݤȰ㤦ĹΤˤʤ
     * @param InterestEmpty Υޥ˶̣뤫
     */
    template <class Function, bool InterestEmpty>
    static void forEachEffectOfPtypeO(const NumEffectState& state, Position, PtypeO,
				      Function& f);
    template <Player P, class Function, bool InterestEmpty>
    static void forEachEffectOfPtypeO(const NumEffectState& state, Position, Ptype,
				      Function& f);
    /**
     * Move m ؤ(open ) Position  f Ϥ.
     * ĹϼʬưαƤ˼⤵Τ˻ߤޤ
     * @param InterestEmpty Υޥ˶̣뤫
     */
    template <class Function, bool InterestEmpty>
    static void forEachEffectOfMove(const NumEffectState& state, Move m, Function& f);
    template <class Function>
    static void forEachEffectPositionOfMove(const NumEffectState& state, Move m, Function& f)
    {
      forEachEffectOfMove<Function,true>(state, m, f);
    }
    template <class Function>
    static void forEachEffectPieceOfMove(const NumEffectState& state, Move m, Function& f)
    {
      forEachEffectOfMove<Function,false>(state, m, f);
    }
    
    /**
     * Move m ؤΡPlayer target ζؤ(open )
     * Ĵ٤(KING ʳ)Ǥͤι⤤֤
     * ̵ Piece::EMPTY() ֤
     */
    static Piece mostValuableEffectOfMoveNotKing(Player target, 
						 const NumEffectState& state, Move m);

    /**
     * Move m ؤΡPlayer target ζؤ(open )
     * Ĵ٤(KING ʳ)Ǥͤι⤤֤
     * ̵ Piece::EMPTY() ֤
     */
    static void mostValuableEffectOfMoveNotKing(Player target, 
						const NumEffectState& state, 
						Move m, CArray<Piece,2>& out);

    /**
     * ̤ȴʤ˹ˡtarget˰ưǽȽ
     * @param king  (̤ǼϹͤʤ)
     * @return ưǽʶ𤬤Сʶġʤ Piece::EMPTY()
     * @see osl::move_classifier::PawnDropCheckmate
     */
    template <Player P>
    static Piece safeCaptureNotByKing(const NumEffectState& state, Position target,
				    Piece king);
    static Piece safeCaptureNotByKing(Player P, const NumEffectState& state, 
				      Position target)
    {
      const Piece king = state.getKingPiece(P);
      if (P == BLACK)
	return safeCaptureNotByKing<BLACK>(state, target, king);
      else
	return safeCaptureNotByKing<WHITE>(state, target, king);
    }

    /**
     * forEachEffect  Player template ̾ΰˤС
     * @param P õоݤζνͭ
     * @param pos Τõ
     */
    template <class Action>
    static void forEachEffect(Player P, const NumEffectState& state, Position pos, 
			      Action& a)
    {
      if (P == BLACK)
	state.template forEachEffect<BLACK>(pos,a);
      else
	state.template forEachEffect<WHITE>(pos,a);
    }
    /**
     * target ΤPieceout˳Ǽ
     */
    static void findEffect(Player P, const NumEffectState& state, Position target,
			   container::PieceVector& out);
    /**
     * frommoveؤmoveؤOpen AttackˤʤäƤ뤫.
     * @param P(template) - moveμΤǤꡤμΤǤץ쥤.
     * @param state - ưξ
     * @param target - Ĵ٤׾ξ
     * @param from - ưζ
     * @param to - ưζ
     */
    template<Player P>
    static bool isOpenAttackMove(const NumEffectState& state, Position target, Position from, Position to);
    /**
     * moveؤ䤹ɤ.
     * @param P(template) - moveμΤǤꡤμΤǤץ쥤.
     * @param state - ưξ
     * @param target - Ĵ٤׾ξ
     * @param move - stateǤPˤˡ
     * ĹϼʬưαƤ˼⤵Τ˻ߤޤ뤬
     * ξϸäʤΤɤȤ롥
     */
    template<Player P>
    static bool isAddEffectMove(const NumEffectState& state, Position target,Move move);

    /**
     * state  position  ptypeo äꤷơҤout˽
     */
    template <class EvalT>
    static void findThreat(const NumEffectState& state, Position position,
			   PtypeO ptypeo, PieceVector& out);

    class SelectMostValuable;
    template <class EvalT>
    class FindThreat;
    template <int N> class SelectMostValuableN;
    class SafeCapture;
  };

  } // namespace effect_util
  using effect_util::EffectUtil;
} // namespace osl

#endif /* _EFFECTUTIL_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
