/* kingArea.h
 */
#ifndef OSL_EVAL_KINGAREA_H
#define OSL_EVAL_KINGAREA_H

#include "osl/eval/experimental/weights.h"
#include "osl/eval/evalTraits.h"
#include "osl/state/numEffectState.h"

namespace osl
{
  namespace eval
  {
    namespace experimental
    {
      class KingArea
      {
      public:
	enum { 
	  range_x = 5,
	  range_y = 4,
	  DIM = range_x*range_y*PTYPE_SIZE*2*32
	};
	
	static int eval(const NumEffectState&, const Weights&);
	static int evalWithUpdate(const NumEffectState& state, Move moved, int last_value, const Weights& values);

	static int index(Player king_owner, int ix, int iy, Position king, Piece p);
	static int index(Player king_owner, int area_id, Position king, bool same, Ptype ptype);
	
	static int areaIdBlack(Position king, Position center, Position target);
	static int areaIdWhite(Position king, Position center, Position target);

	static int pieceValue(const NumEffectState& state, Piece p, const Weights&);
      };
    }
  }
}


#endif /* OSL_EVAL_KINGAREA_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
