/* midgameEval.h
 */
#ifndef EVAL_MIDGAMEEVAL_H
#define EVAL_MIDGAMEEVAL_H

#include "osl/eval/pieceEval.h"
#include "osl/state/numEffectState.h"
#include "osl/container/pieceValues.h"
#include "osl/progress/progress16.h"
#include <boost/static_assert.hpp>

namespace osl
{
  namespace eval
  {
    namespace experimental
    {
      class MidgameEval
      {
      private:
	enum {
	  INVALID=EvalTraits<BLACK>::MAX_VALUE+1,
	};
	PieceEval piece;
	CArray<int,3> values;
      public:
	static const int ROUND_UP = 2;
	static int roundUp(int v)
	{
	  return v & (~(ROUND_UP-1)); 
	}

	MidgameEval(const NumEffectState& state);
	void changeTurn() {}
	static bool initialized();
	static bool setUp(const char *filename);
	static bool setUp();

	int value() const
	{
	  int ret = 0;
	  for (size_t i=0; i<values.size(); ++i)
	    ret += values[i];
	  ret = ret*5/8;
	  ret += piece.value();
	  ret = roundUp(ret);
	  return ret;
	}
	int elementValue(size_t i) const { return values[i]; }
	void update(const NumEffectState& new_state, Move last_move);
	int expect(const NumEffectState& /*state*/, Move move) const { 
	  return value() + captureValue(move.ptypeO()); 
	}

	static int pieceValue(const NumEffectState&, Piece);
	static void setValues(const SimpleState& s, container::PieceValues& o);
	static void showEvalSummary(const NumEffectState&);
      public:
	static int infty()
	{
	  return PieceEval::infty()*2;
	}
	static int captureValue(PtypeO ptypeO)
	{
	  return PieceEval::captureValue(ptypeO);
	}
      };
    }
  } // namespace eval
} // namespace osl

#endif /* EVAL_MIDGAMEEVAL_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
