/* ptypeAttackedLong.h
 */
#ifndef OSL_EVAL_PTYPEATTACKEDLONG_H
#define OSL_EVAL_PTYPEATTACKEDLONG_H

#include "osl/eval/experimental/weights.h"
#include "osl/state/numEffectState.h"

namespace osl
{
  namespace eval
  {
    namespace experimental
    {
      class PtypeAttackedLong
      {
      public:
	enum { DIM = (PTYPE_MAX+1-PTYPE_PIECE_MIN)*6 };
	static int eval(const NumEffectState&, const Weights&);

	static int pieceValue(const NumEffectState& state, Piece p, const Weights&);
	static int index(Piece, const NumEffectState& state);
	static int index(Ptype self, Ptype attack, bool has_support)
	{
	  assert(attack == LANCE || attack == BISHOP || attack == ROOK);
	  const int attack_base = (attack == LANCE) ? 0 : attack - BISHOP + 1;
	  return (self-PTYPE_PIECE_MIN)*6+attack_base*2+has_support;
	}
      };
    }
  }
}


#endif /* OSL_EVAL_PTYPEATTACKEDLONG_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
