/* kingMobility.h
 */
#ifndef _KING_MOBILITY_H
#define _KING_MOBILITY_H

#include "osl/misc/carray.h"
#include "osl/player.h"

#ifndef USE_SSE
#define USE_SSE 1
#define USE_SSE41 0
#endif

namespace osl
{
  namespace mobility
  {
    typedef long long v2di __attribute__ ((vector_size (16)));
    class KingMobility{
      union b128{
	CArray<CArray<unsigned char,8>,2> uc16;
	unsigned long long ul[2];
	v2di v2;
      } v __attribute__((aligned(16)));
    public:
      KingMobility() {
      }
      const CArray<unsigned char,8>& operator[](Player p) const{
	return v.uc16[p];
      }
      CArray<unsigned char,8>& operator[](Player p){
	return v.uc16[p];
      }
      KingMobility& operator=(KingMobility const& km){
	v.v2=km.v.v2;
	return *this;
      }
      bool operator==(KingMobility const& km) const{
#if USE_SSE41
	return __builtin_ia32_ptestz128(v.v2,km.v.v2);
#else
	return ((v.ul[0]^km.v.ul[0])|(v.ul[1]^km.v.ul[1]))==0;
#endif
      }
    };
  }
  using mobility::KingMobility;
}
#endif /* _KING_MOBILITY_H */
  // ;;; Local Variables:
  // ;;; mode:c++
  // ;;; c-basic-offset:2
  // ;;; End:
