#ifndef _MOVE_ACTION_CONCEPT_H
#define _MOVE_ACTION_CONCEPT_H

#include "osl/position.h"
#include "osl/player.h"
#include "osl/piece.h"
#include "osl/ptype.h"
#include <boost/concept_check.hpp>

namespace osl
{
  namespace move_action
  {
    /**
     * interface 
     */
    class MoveAction 
    {
    public:
      /** ޤȤʤMove */
      void simpleMove(Position from,Position to,Ptype ptype, 
			     bool isPromote,Player p);

      /** ޤ뤫⤷ʤ Move */
      void unknownMove(Position from,Position to,Piece captured,
			      Ptype ptype,bool isPromote,Player p);
      /** ޤǤMove */
      void dropMove(Position to,Ptype ptype,Player p);
    };

    /**
     * MoveAction .
     * http://www.boost.org/libs/concept_check/concept_check.htm
     */
    template <class T>
    struct Concept
    {
      /**  */
      void constraints() 
      {
	// MoveAction must have the following three methods

	// Ժ
	// ƽФinlineŸʤɤǥѥ֤Τ
	// ɥ쥹ȤˤƤߤ
	simple  = &T::simpleMove;
	unknown = &T::unknownMove;
	drop    = &T::dropMove;
      }
      void (T::*simple)(Position, Position, Ptype, bool, Player);
      void (T::*unknown)(Position, Position, Piece, Ptype, bool, Player);
      void (T::*drop)(Position, Ptype, Player);
    };
  } // namespace move_action
} // namespace osl


#endif /* _MOVE_ACTION_CONCEPT_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
