/* kingOpenMove.h
 */
#ifndef _MOVE_CLASSIFIER_KING_OPEN_MOVE_H
#define _MOVE_CLASSIFIER_KING_OPEN_MOVE_H

#include "osl/move_classifier/classifierTraits.h"
#include "osl/state/numEffectState.h"
#include "osl/player.h"
#include "osl/ptype.h"

namespace osl
{
  namespace move_classifier
  {
    /**
     * Pβopen checkˤǤʤȤå.
     * - P==move playerλϼ꤫ɤΥå˻Ȥ.
     *      ưˤϸƤ٤ʤ
     * - P!=move playerλ̾open checkɤ˻Ȥ.
     * - DropMoveλˤϸƤ٤ʤ
     */
    template <Player P>
    struct KingOpenMove
    {
      static bool isMember(const NumEffectState& state, 
			   Ptype ptype,Position from,Position to)
      {
	if (! state.selectLong(from, alt(P)).any())
	  return false;
	int num=state.getPieceAt(from).number();
	assert(Piece::isPieceNum(num));
	if(!state.pinOrOpen(P).test(num)) return false;
	// from to kingľ¤٤ false
	Position king=state.getKingPosition<P>();
	return Board_Table.getShortOffsetNotKnight(Offset32(king,to))
	  != Board_Table.getShortOffsetNotKnight(Offset32(king,from));
      }
      /**
       * @param exceptFor Ͻ
       */
      static bool isMember(const NumEffectState& state, 
			   Ptype ptype,Position from,Position to,
			   Position exceptFor)
      {
	return isMemberMain<true>(state, ptype, from, to, exceptFor);
      }
    private:
      template <bool hasException>
      static bool isMemberMain(const NumEffectState& state, 
			       Ptype ptype,Position from,Position to,
			       Position exceptFor);
    };

    template <Player P> struct ClassifierTraits<KingOpenMove<P> >
    {
      static const bool drop_suitable = false;
      static const bool result_if_drop = false;
    };
    
  } // namespace move_classifier
} // namespace osl
#endif /* _MOVE_CLASSIFIER_NOT_KING_OPEN_MOVE_H */

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
