#ifndef _NTESUKI_NTESUKI_RECORD_H
#define _NTESUKI_NTESUKI_RECORD_H
#include "osl/ntesuki/ntesukiResult.h"
#include "osl/ntesuki/ntesukiMove.h"
#include "osl/ntesuki/ntesukiMoveList.h"
#include "osl/ntesuki/rzone.h"
#include "osl/ntesuki/ntesukiExceptions.h"
#include "osl/checkmate/checkAssert.h"
#include "osl/misc/carray.h"
#include "osl/state/hashEffectState.h"
#include "osl/container/moveVector.h"
#include "osl/pathEncoding.h"
#include <iosfwd>

namespace osl
{
  namespace ntesuki
  {
    class NtesukiRecord;
    class PathEncodingList : public slist<PathEncoding>
    {
    };

    class NtesukiMoveGenerator;
    class NtesukiTable;

    /**
     * ̤ˤĤơζ̤ nꤹõ
     * ̤ݻƤ饹.
     */

    class NtesukiRecord
    {
    public:
      typedef slist<NtesukiRecord> RecordList;
      typedef slist<NtesukiRecord*> RecordPList;
      /**
       * Υ. SIZE - 1 ꤹޤĴ٤.
       */
      static const unsigned int SIZE = 2;
      enum IWScheme { no_iw = 0,
		      strict_iw = 1,
		      pn_iw = 2 };

      enum PSScheme { no_ps = 0,
		      pn_ps = 1 };

      enum ISScheme { no_is = 0,
		      tonshi_is = 1,
		      delay_is = 2,
		      normal_is = 3 };

      /**
       * õطοʾ.
       */
      static unsigned int fixed_search_depth;
      static unsigned int inversion_cost;
      static bool use_dominance;
      static int pass_count;
      static bool max_for_split;
      static bool use_rzone_move_generation;
      static bool delay_lame_long;
      static bool use_9rzone;

      static NumEffectState *state;
      static NtesukiMoveGenerator *mg;
      static NtesukiTable *table;

      /* DAGط׾ */
      static unsigned int split_count /** ʬήĤ뤫. */,
	confluence_count /** ήĤ뤫. */;

      /* Visit Lock */
      class VisitLock;
      class UnVisitLock;

      /** ƥץ쥤λ */
      PieceStand black_stand, white_stand;

      /** root κû path εΥ */
      unsigned short distance;

      /** ̤ HashKey */
      HashKey key;

      /** ̡֤Ʊǡ㤦̤Υꥹ */
      RecordList *same_board_list;

      /** ƶ̤Υꥹ */
      RecordPList parents;
      int rev_refcount;/* ҤƤؤ reference  count */

      /**
       * 󥹥ȥ饯.
       */
      NtesukiRecord(signed short distance,
		    const HashKey& key,
		    const PieceStand& white_stand,
		    RecordList* same_board_list);
      ~NtesukiRecord()
      {
      }

      /**  */
      Player turn() const
      {
	return key.turn();
      }

      /** simulation ˤäͤޤä */
      bool isBySimulation() const
      {
	return by_simulation;
      }

      /**
       * ζ̤ǤΥץ쥤λ.
       * - @const P ץ쥤
       */
      template<Player P> const PieceStand&
      getPieceStand() const
      {
	return piece_stand<P>();
      }

      const PieceStand&
      getPieceStandSlow(Player P) const
      {
	if (P == BLACK)
	{
	  return piece_stand<BLACK>();
	}
	else
	{
	  return piece_stand<WHITE>();
	}
      }

      /**
       * ׻.
       * - @const A ¦Υץ쥤
       */
      template <Player A>
      PieceStand
      calcProofPiecesOr(int pass_left,
			const NtesukiMove& m);

      template <Player A>
      PieceStand
      calcProofPiecesAnd(int pass_left);
      
      /**
       * ꤹ.
       * - @const A ¦Υץ쥤
       */
      template <Player A>
      void
      setProofPieces(int pass_left,
		     const NtesukiResult& r,
		     const NtesukiMove& m,
		     const PieceStand* ps);
      /**
       * ȿڶꤹ.
       * - @const A ¦Υץ쥤
       */
      template <osl::Player A>
      void
      setDisproofPieces(int pass_left,
			const NtesukiResult& r,
			const NtesukiMove& m,
			const PieceStand* ps);
      /**
       * õη̤Ǽ
       * - @const A ¦Υץ쥤
       */
      template <Player A> void
      setResult(int i,
		const NtesukiResult& r,
		const NtesukiMove& m,
		bool bs,
		const PieceStand* ps = NULL);

      /** ΥΡɤ NtesukiResult ͤĴ٤
       * - @const A ¦Υץ쥤
       */
      template <Player A> const NtesukiResult getValue(int i) const;
      template <Player A> const NtesukiResult getValueWithPath(int i,
							       const PathEncoding path) const;
      template <Player A> const NtesukiResult getValueOr(int i,
							 const PathEncoding path,
							 IWScheme iwscheme) const;
      template <Player A> const NtesukiResult getValueAnd(int i,
							  const PathEncoding path,
							  IWScheme iwscheme, PSScheme psscheme) const;
      const NtesukiResult getValueSlow(const Player attacker, int i) const;
      const NtesukiResult getValueOfTurn(int i) const;
      const NtesukiResult valueBeforeFinal() const;

      /* Ĵ٤.
       * ä pass_left 
       * ʳä SIZE ֤.
       */
      int isWin(const Player attacker) const
      {
	int o = 0;
	for (; o < (int)SIZE; o++)
	{
	  if (getValueSlow(attacker, o).isCheckmateSuccess())
	  {
	    break;
	  }
	}
	return o;
      }
      

      /**
       * ϿƤ֤.
       */
      template <Player A> const NtesukiMove& getBestMove(int i) const;
      const NtesukiMove& getBestMoveSlow(Player attacker, int i) const;

      /**
       * Loop ˤʤäƤ뤫å.
       */
      bool isVisited() const { return visited; }
      bool isFinal() {return final; }

      void setVisited()
      {
	assert (!visited);
	visited = true;
      }

      void resetVisited()
      {
	assert (visited);
	visited = false;
      }

      /**
       * Fixed Depth Searcher ˤäͤꤵ줿.
       */
      template <Player A> bool isByFixed() const;
      bool isByFixedSlow(Player attacker) const;
      
      /**
       * ΥΡɤ nꤹˤʤäƤ뤫.
       */
      template <Player A> bool isNtesuki(int pass_left) const;
      template <Player A> void setNtesuki(int pass_left);

      /**
       * ΥΡɤǿƤ褿 oracle 
       */
      template <Player A> bool hasTriedPropagatedOracle(int pass_left) const;
      template <Player A> void triedPropagatedOracle(int pass_left);

      /**
       * 
       */
      template <Player A> PieceStand getPDPieces(int pass_left) const;
      PieceStand getPDPiecesSlow(Player attacker, int pass_left) const;
      template <Player A> void setPDPieces(int pass_left, const PieceStand p);

      /**
       * ̵̹礤ɤ٤.
       */
      bool readInterpose(int pass_left) const
      {
	return read_interpose[pass_left];
      }

      void setReadInterpose(int pass_left)
      {
	read_interpose[pass_left] = true;
      }

      /**
       * defense κݤ˲ɤ٤.
       */
      bool readCheckDefense(int pass_left) const
      {
	return read_check_defense[pass_left];
      }

      void setReadCheckDefense(int pass_left)
      {
	read_check_defense[pass_left] = true;
      }

      /**
       * attack κݤˡҥ塼ꥹƥåȽ̤줿ʳɤफ.
       */
      bool readNonAttack(int pass_left) const
      {
	return read_non_attack[pass_left];
      }

      void setReadNonAttack(int pass_left)
      {
	read_non_attack[pass_left] = true;
      }

      /**
       * old child ɤ٤.
       */
      template <Player A> bool
      useOld(int pass_left) const;
      
      template <Player A> void
      setUseOld(int pass_left,
		 bool value);
      
      /**
       *  path  loop ˤʤ뤫
       */
      template <Player A> bool
      isLoopWithPath(int pass_left,
		     const PathEncoding& path) const;

      template <Player A> void
      setLoopWithPath(int pass_left,
		      const PathEncoding& path);

      template <Player A> bool
      hasLoop(int pass_left) const
      {
	return !loop_path_list<A>()[pass_left].empty();
      }

      /**
       * Fixed Depth Searcher Ƥ.
       */
      template <Player P> bool
      setUpNode();

      /* ΤäƤʤ. */
      template <Player P> void
      setUpAttackNode();

      /* ΤäƤ. */
      template <Player P> void
      setUpDefenseNode();

      /* ҥΡɤξȤäƸߤξ򹹿. */
      void
      updateWithChild(NtesukiRecord* child,
		      int pass_left);
      
      /**
       * .
       */
      template <Player P> void
      generateMoves(NtesukiMoveList& moves,
		    int pass_left,
		    bool all_moves);


      bool operator==(const NtesukiRecord& record)
      {
	return key == record.key;
      }

      /* GC ط */
      unsigned int getChildCount() const
      {
	return child_count;
      }

      void addChildCount(unsigned int i)
      {
	child_count += i;
      }

      unsigned int getReadCount() const
      {
	return read_count;
      }

      unsigned int getWrittenCount() const
      {
	return written_count;
      }

      /* DAG кط */
    private:
      bool isNewParent(const NtesukiRecord* p) const
      {
	for (RecordPList::const_iterator it = parents.begin();
	     it != parents.end(); ++it)
	{
	  if (*it == p) return false;
	}
	return true;
      }

      void find_split(NtesukiRecord *rhs,
		      RecordPList& lvisited,
		      RecordPList& rvisited)
      {
	if (find_split_right(rhs, lvisited, rvisited))
	{
	  return;
	}

#if 1
	if (parents.empty())
	{
	  return;
	}
	/* ǽΰĤοƤ */
	RecordPList::iterator lp = parents.begin();
	if (std::find(lvisited.begin(), lvisited.end(), *lp)
	    != lvisited.end())
	{
	  return;
	}
	lvisited.push_front(*lp);
	(*lp)->find_split(rhs, lvisited, rvisited);
	lvisited.pop_front();
#else
	for (RecordPList::iterator lp = parents.begin();
	     lp != parents.end(); ++lp)
	{
	  if (std::find(lvisited.begin(), lvisited.end(), *lp)
	      == lvisited.end())
	  {
	    lvisited.push_front(*lp);
	    (*lp)->find_split(rhs, lvisited, rvisited);
	    lvisited.pop_front();
	  }
	}
#endif
      }

      /* find_split ĤǤȤȡ O(n^2) ǺѤȤ O(2^n) Τ */
      bool find_split_right(NtesukiRecord *rhs,
			    RecordPList& lvisited,
			    RecordPList& rvisited)
      {
	if (this == rhs)
	{
	  if (!is_split)
	  {
	    ++split_count;
	    is_split = true;
	  }
	  return true;
	}

#if 1
	if (rhs->parents.empty())
	{
	  return false;
	}
	/* ǽΰĤοƤ */
	RecordPList::iterator rp = rhs->parents.begin();
	if (std::find(rvisited.begin(), rvisited.end(), *rp)
	    != rvisited.end())
	{
	  return false;
	}
	rvisited.push_front(*rp);
	bool result = find_split_right(*rp, lvisited, rvisited);
	rvisited.pop_front();
	return result;
#else
	bool result = false;
	for (RecordPList::iterator rp = rhs->parents.begin();
	     rp != rhs->parents.end(); ++rp)
	{
	  if (std::find(rvisited.begin(), rvisited.end(), *rp)
	      == rvisited.end())
	  {
	    rvisited.push_front(*rp);
	    result |= find_split_right(*rp, lvisited, rvisited);
	    rvisited.pop_front();
	  }
	}
	return result;
#endif
      }

      void addNewParent(NtesukiRecord* p)
      {
	ntesuki_assert(isNewParent(p));
	parents.push_front(p);
	p->rev_refcount++;
      }

    public:
      void checkNewParent(NtesukiRecord *p)
      {
	if (parents.empty())
	{
	  /* allocate 줿Фʤ顤 parent  add ƽλ */
	  addNewParent(p);
	}
	else if (isNewParent(p))
	{
	  ++confluence_count;
	  if (max_for_split)
	  {
	    /* DAG ʬή()õ
	     */
	    RecordPList lvisited, rvisited;
	    lvisited.push_front(this);
	    rvisited.push_front(p);
	    find_split(p, lvisited, rvisited);
	  }
	  addNewParent(p);
	}
      }

    private:
      typedef CArray<NtesukiResult, SIZE> values_t;
      typedef CArray<NtesukiMove, SIZE> moves_t;
      typedef CArray<short, SIZE - 1> nodesread_t;
      typedef CArray<PieceStand, SIZE> pdpieces_t;
      typedef CArray<bool, SIZE> flags_t;
      typedef CArray<PathEncodingList, SIZE> pell_t;
      typedef CArray<Rzone, SIZE> rzones_t;
      values_t values_black, values_white;
      moves_t best_move_black, best_move_white;
      pdpieces_t pd_pieces_black, pd_pieces_white;
      /** Ʊζ̤ǡLoop ˤʤäƤΤ Path */
      pell_t loop_path_list_black, loop_path_list_white;
      mutable unsigned int child_count, read_count, written_count;

      NtesukiResult value_before_final;/** setResult  final ͤꤵľ result  */

      bool visited;
      bool by_simulation;
      bool by_fixed_black, by_fixed_white;
      bool already_set_up;
      bool final;

    public:
      bool is_split; /** DAG ʬή */
      bool do_oracle_attack;
      /* ANDˤĤơ pass_left = 0  disproof
       * 줿硤ѥãǤˤĤơ
       * simulation 򤹤.
       */
      bool do_oracle_aunt;

      /* OR ǡrzone Ѥ򤹤 */
      bool rzone_move_generation;

    private:
      flags_t read_interpose;/* ǤΤ߻Ȥ */
      flags_t read_check_defense;/* ǤΤ߻Ȥ */
      flags_t read_non_attack;/* ǤΤ߻Ȥ */
      flags_t is_ntesuki_black, is_ntesuki_white;
      flags_t propagated_oracle_black, propagated_oracle_white;
      flags_t use_old_black, use_old_white;
      rzones_t rzone_black, rzone_white;
      
      NtesukiRecord();

      template <Player P> bool& by_fixed()
      {
	if (P == BLACK)
	  return by_fixed_black;
	else
	  return by_fixed_white;
      }

      template <Player P> const bool& by_fixed() const
      {
	if (P == BLACK)
	  return by_fixed_black;
	else
	  return by_fixed_white;
      }

      template <Player P> PieceStand& piece_stand()
      {
	if (P == BLACK)
	  return black_stand;
	else
	  return white_stand;
      }

      template <Player P> const PieceStand& piece_stand() const
      {
	if (P == BLACK)
	  return black_stand;
	else
	  return white_stand;
      }

      template <Player P> values_t& values()
      {
	if (P == BLACK)
	  return values_black;
	else
	  return values_white;
      }

      template <Player P> const values_t& values() const
      {
	if (P == BLACK)
	  return values_black;
	else
	  return values_white;
      }

      template <Player P> moves_t& best_move()
      {
	if (P == BLACK)
	  return best_move_black;
	else
	  return best_move_white;
      }

      template <Player P> const moves_t& best_move() const
      {
	if (P == BLACK)
	  return best_move_black;
	else
	  return best_move_white;
      }

      template <Player P> pdpieces_t& pdpieces()
      {
	if (P == BLACK)
	  return pd_pieces_black;
	else
	  return pd_pieces_white;
      }

      template <Player P> const pdpieces_t& pdpieces() const
      {
	if (P == BLACK)
	  return pd_pieces_black;
	else
	  return pd_pieces_white;
      }

      template <Player P> flags_t& is_ntesuki()
      {
	if (P == BLACK)
	  return is_ntesuki_black;
	else
	  return is_ntesuki_white;
      }

      template <Player P> const flags_t& is_ntesuki() const
      {
	if (P == BLACK)
	  return is_ntesuki_black;
	else
	  return is_ntesuki_white;
      }

      template <Player P> flags_t& propagated_oracle()
      {
	if (P == BLACK)
	  return propagated_oracle_black;
	else
	  return propagated_oracle_white;
      }

      template <Player P> const flags_t propagated_oracle() const
      {
	if (P == BLACK)
	  return propagated_oracle_black;
	else
	  return propagated_oracle_white;
      }

      template <Player P> flags_t& use_old()
      {
	if (P == BLACK)
	  return use_old_black;
	else
	  return use_old_white;
      }

      template <Player P> const flags_t use_old() const
      {
	if (P == BLACK)
	  return use_old_black;
	else
	  return use_old_white;
      }

      template <Player P> pell_t& loop_path_list()
      {
	if (P == BLACK)
	  return loop_path_list_black;
	else
	  return loop_path_list_white;
      }

      template <Player P> const pell_t& loop_path_list() const
      {
	if (P == BLACK)
	  return loop_path_list_black;
	else
	  return loop_path_list_white;
      }

    public:
      template <osl::Player P> rzones_t& rzone()
      {
	if (P == BLACK)
	  return rzone_black;
	else
	  return rzone_white;
      }
    private:
      template <Player P> void
      setFinal(int i,
	       const NtesukiResult& r,
	       const NtesukiMove& m,
	       const PieceStand* ps);

      /**
       * Dominace .
       */
      void lookup_same_board_list();

      template <Player P>
      void propagate_proof(int pass_left);

      template <Player P>
      void propagate_disproof(int pass_left);

    public:
      template <Player P>
      bool isDominatedByProofPieces(const NtesukiRecord* record,
				    int pass_left) const;

      template <Player P>
      bool isDominatedByDisproofPieces(const NtesukiRecord* record,
				       int pass_left) const;

      template <Player P>
      bool isBetterFor(NtesukiRecord* record);
    };
    std::ostream& operator<<(std::ostream&, const osl::ntesuki::NtesukiRecord&);

    std::ostream& operator<<(std::ostream&,
			     const osl::ntesuki::NtesukiRecord::IWScheme&);
    std::istream& operator>>(std::istream&,
			     osl::ntesuki::NtesukiRecord::IWScheme&);

    std::ostream& operator<<(std::ostream&,
			     const osl::ntesuki::NtesukiRecord::PSScheme&);
    std::istream& operator>>(std::istream&,
			     osl::ntesuki::NtesukiRecord::PSScheme&);

    std::ostream& operator<<(std::ostream&,
			     const osl::ntesuki::NtesukiRecord::ISScheme&);
    std::istream& operator>>(std::istream&,
			     osl::ntesuki::NtesukiRecord::ISScheme&);

    class NtesukiRecord::VisitLock
    {
      NtesukiRecord* record;
    public:
      VisitLock(NtesukiRecord* record)
	: record(record)
      {
	assert(!record->isVisited());
	record->setVisited();
      }
      ~VisitLock()
      {
	assert(record->isVisited());
	record->resetVisited();
      }
    };

    class NtesukiRecord::UnVisitLock
    {
      NtesukiRecord* record;
    public:
      UnVisitLock(NtesukiRecord* record)
	: record(record)
      {
	assert(record->isVisited());
	record->resetVisited();
      }
      ~UnVisitLock()
      {
	assert(!record->isVisited());
	record->setVisited();
      }
    };
  }//ntesuki
}//osl

#endif /* _NTESUKI_NTESUKI_RECORD_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
