/* DiagonalPreconditioner.h
 */
#ifndef _STAT_DIAGONALPRECONDITIONER_H
#define _STAT_DIAGONALPRECONDITIONER_H

#include "osl/stat/preconditioner.h"
#include <boost/scoped_array.hpp>
#include <cstddef>

namespace osl
{
  namespace stat
  {

    class DiagonalPreconditioner : public Preconditioner
    {
      boost::scoped_array<double> m_diagonals;
      size_t m_dim;
    public:
      // CREATORS
      explicit DiagonalPreconditioner(size_t dim);
      ~DiagonalPreconditioner();
      // MANIPULATORS
      void setInverseDiagonals(const double *inverse_diagonals);
    
      // ACCESSORS
      void solve(const double*x, double *out) const;
    };

  } // namespace stat
} // namespace osl


#endif /* _STAT_DIAGONALPRECONDITIONER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
