/* ptypePosition.cc
 */
#include "osl/eval/experimental/ptypePosition.h"

int osl::eval::experimental::
PtypePosition::eval(const NumEffectState& state, const Weights& values)
{
  int result = 0;
  for (int i=0; i<40; ++i) {
    Piece p = state.getPieceOf(i);
    if (! p.isOnBoard())
      continue;
    const int value = weight(p.owner(), index(p), values);
    result += value;
  }
  return result;
}

int osl::eval::experimental::
PtypePosition::pieceValue(const NumEffectState&, Piece p, const Weights& values)
{
  if (! p.isOnBoard())
    return 0;
  return weight(p.owner(), index(p), values);
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
