/* ntesukiList.cc
 */
#include "osl/ntesuki/ntesukiMoveList.h"
#include <iostream>

osl::ntesuki::NtesukiMoveList::
NtesukiMoveList()
{
}

osl::ntesuki::NtesukiMoveList::
NtesukiMoveList(const NumEffectState& state,
		const osl::MoveVector& mv)
{
  ntesuki_assert(empty());
  if (!state.getKingPosition(alt(state.getTurn())).isOnBoard())
  {
    for (size_t i = 0; i < mv.size(); ++i)
    {
      NtesukiMove move(mv[i]);
      push_front(move);
    }
  }
  else
  {
    for (size_t i = 0; i < mv.size(); ++i)
    {
      NtesukiMove move(mv[i]);
      if (move_classifier::PlayerMoveAdaptor<move_classifier::Check>::isMember(state, mv[i]))
      {
	move.setCheck();
      }
      push_front(move);
    }
  }
}

/*
 * ʣ򤷤ʤ褦˼ɲä᥽å.
 * @c move 뤫ɤܤäˤ
 * ˤ move ؤλȤ֤.
 * ʤäˤ @c move Ʊ osl::Move Ĥ褦
 * NtesukiMove ɲä.
 * Ԥ˴ط flags  record ξݻʤΤ.
 * ̾ɲäξˤ push_front Ѥ뤳.
 */
const osl::ntesuki::NtesukiMove& osl::ntesuki::NtesukiMoveList::
find(const NtesukiMove& move) const
{
  const_iterator it;
  for (it = begin(); it != end(); it++)
  {
    if(it->getMove() == move.getMove())
    {
      return *it;
    }
  }

  return *it;
}

osl::ntesuki::NtesukiMove* osl::ntesuki::NtesukiMoveList::
add(const NtesukiMove& move)
{
  for (iterator it = begin(); it != end(); it++)
  {
    if(it->getMove() == move.getMove())
    {
      return &(*it);
    }
  }

  push_front(NtesukiMove(move.getMove()));
  if (move.isCheck())
  {
    front().setCheck();
  }
  return &(front());
}

std::ostream& osl::ntesuki::
operator<<(std::ostream& os, const NtesukiMoveList& l)
{
  for (NtesukiMoveList::const_iterator p=l.begin(); p!=l.end(); ++p)
  {
    os << (*p) << " ";
  }
  return os << "\n";
}

