#include "osl/container/tripleInt.h"
#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>

using namespace osl;

class TripleIntTest : public CppUnit::TestFixture 
{
  CPPUNIT_TEST_SUITE(TripleIntTest);
  CPPUNIT_TEST(testAdd);
  CPPUNIT_TEST_SUITE_END();
 public:
  void testAdd();
};

CPPUNIT_TEST_SUITE_REGISTRATION(TripleIntTest);

void TripleIntTest::testAdd(){
  TripleInt a, b;
  CPPUNIT_ASSERT_EQUAL(a[0], 0);
  CPPUNIT_ASSERT_EQUAL(a[1], 0);
  CPPUNIT_ASSERT_EQUAL(a[2], 0);
  CPPUNIT_ASSERT_EQUAL(b[0], 0);
  CPPUNIT_ASSERT_EQUAL(b[1], 0);
  CPPUNIT_ASSERT_EQUAL(b[2], 0);

  a[0] = 1; a[1] = 2; a[2] = 3;
  b[0] = 7; b[1] = 16; b[2] = 27;
  
  TripleInt c = a + b, d = a - b;
  CPPUNIT_ASSERT_EQUAL(c[0], 8);
  CPPUNIT_ASSERT_EQUAL(c[1], 18);
  CPPUNIT_ASSERT_EQUAL(c[2], 30);

  CPPUNIT_ASSERT_EQUAL(d[0], -6);
  CPPUNIT_ASSERT_EQUAL(d[1], -14);
  CPPUNIT_ASSERT_EQUAL(d[2], -24);
}

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
